/* ADD the appropriate parts to stucts.h */

#define SPELL_LEVEL_0     0 /* not currently used */
#define SPELL_LEVEL_1     1
#define SPELL_LEVEL_2     2
#define SPELL_LEVEL_3     3
#define SPELL_LEVEL_4     4
#define SPELL_LEVEL_5     5
#define SPELL_LEVEL_6     6
#define SPELL_LEVEL_7     7
#define SPELL_LEVEL_8     8

#define MAX_SPELL_LEVEL   9                     /* how many spell levels */
#define MAX_MEM          (MAX_SPELL_LEVEL * 10) /* how many total spells */


struct player_special_data_saved {
   byte skills[MAX_SKILLS+1];	/* array of skills plus skill 0		*/
   byte PADDING0;		/* used to be spells_to_learn		*/
   bool talks[MAX_TONGUE];	/* PC s Tongues 0 for NPC		*/

   int	wimp_level;		/* Below this # of hit points, flee!	*/
   byte freeze_level;		/* Level of god who froze char, if any	*/
   sh_int invis_level;		/* level of invisibility		*/
   room_vnum load_room;		/* Which room to place char in		*/
   int pref[PR_ARRAY_MAX];	/* preference flags for PC's.		*/
   ubyte bad_pws;		/* number of bad password attemps	*/
   sbyte conditions[3];         /* Drunk, full, thirsty			*/

   int spells_to_learn;	              /* How many can you learn yet this level*/
   int olc_zone;
>>>>   int spellmem[MAX_MEM];
};

struct player_special_data {
   struct player_special_data_saved saved;

   char	*poofin;		/* Description on arrival of a god.     */
   char	*poofout;		/* Description upon a god's exit.       */
   struct alias_data *aliases;	/* Character's aliases			*/
   long last_tell;		/* idnum of last tell from		*/
   void *last_olc_targ;		/* olc control				*/
   int last_olc_mode;		/* olc control				*/
   char *host;			/* player host				*/
>>>   int spell_level[MAX_SPELL_LEVEL];  /* bonus to number of spells memorized */ 
>>>   int memcursor;               /* points to the next free slot in spellmem */
   int cast_wait;               /* how many ticks till spell is cast    */
};


/* this can be used for skills that can be used per-day */
struct memorize_node {
	int      timer;       /* how many ticks left till memorized (standing) */
	int      spell;       /* the spell number */

	struct memorize_node *next; /* link to the next node */
};

struct innate_node {
   int timer;
   int spellnum;

   struct innate_node *next;
};

/* ================== Structure for player/non-player ===================== */
struct char_data {
   int pfilepos;			 /* playerfile pos		  */
   mob_rnum nr;                          /* Mob's rnum			  */
   room_rnum in_room;                    /* Location (real room number)	  */
   room_rnum was_in_room;		 /* location for linkdead people  */
   int wait;				 /* wait for how many loops	  */

   struct char_player_data player;       /* Normal data                   */
   struct char_ability_data real_abils;	 /* Abilities without modifiers   */
   struct char_ability_data aff_abils;	 /* Abils with spells/stones/etc  */
   struct char_point_data points;        /* Points                        */
   struct char_special_data char_specials;	/* PC/NPC specials	  */
   struct player_special_data *player_specials; /* PC specials		  */
   struct mob_special_data mob_specials;	/* NPC specials		  */

   struct affected_type *affected;       /* affected by what spells       */
   struct obj_data *equipment[NUM_WEARS];/* Equipment array               */

   struct obj_data *carrying;            /* Head of list                  */
   struct descriptor_data *desc;         /* NULL for mobiles              */

   struct char_data *next_in_room;     /* For room->people - list         */
   struct char_data *next;             /* For either monster or ppl-list  */
   struct char_data *next_fighting;    /* For fighting list               */

   struct follow_type *followers;        /* List of chars followers       */
   struct char_data *master;             /* Who is char following?        */

   long id;                            /* used by DG triggers */
   struct trig_proto_list *proto_script; /* list of default triggers */
   struct script_data *script;         /* script info for the object */
   struct script_memory *memory;       /* for mob memory triggers */

>>>   struct memorize_node *memorized;
>>>   struct innate_node *innate;
};


struct int_app_type {
   byte learn;       /* how many % a player learns a spell/skill */
   sh_int memspeed;
};

